;												
; RDS-OLED-DECODER fr ATmega8					
; Bernhard.Erfurt@gmx.de						
; 06/2014										
;												
; LCD 4x20										
;												
; TAKT 16 MHz									
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==> INPUT-TASTE							
; PB1 ==> INPUT-TASTE							
; PB2 ==> LCD (D4)								
; PB3 ==> LCD (D5)								
; PB4 ==> LCD (D6)								
; PB5 ==> LCD (D7)								
; PB6 ==> Quarz									
; PB7 ==> Quarz									
;												
; PC0 ==> LCD R/S								
; PC1 ==> LCD E									
; PC2 ==> RELAIS								
; PC3 ==> 										
; PC4 ==> 										
; PC5 ==> 										
;												
; PD0 ==> OUT-BEEP								
; PD1 ==> OUT-USART								
; PD2 ==> INPUT-TAKT (INT0)						
; PD3 ==> INPUT-FREQUENZZHLER					
; PD4 ==> INPUT_DATA							
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; Abfrage der Tasten bei jedem RDS-TAKT

; ATmega8 										
.include "m8def.inc"
; KONSTANTEN									
.equ TAKT							=16000000	; 16 MHz	
; TIMER-WERTE										
.equ TIMERWERT1						=65536-15625;(2 hoch 16 minus....15625) bei 16MHz + Vorteiler 1024 => 1s 		

; FEHLER-CODES									
.equ ERROR_RDS_BUFFER				= 20
; TASTENBELEGUNG								
.equ TASTE_MENUE_PLUS				= 1
.equ TASTE_MENUE_MINUS				= 2
.equ TASTE_RESET					= 3
; RDS											
.equ  POLYNOM    			= 0x5B9
.equ  OFFSET_WORD_A  		= 0x0FC
.equ  OFFSET_WORD_B  		= 0x198
.equ  OFFSET_WORD_C  		= 0x168
.equ  OFFSET_WORD_D  		= 0x1B4
; EINGANG RDS-TAKT								
.equ TAKT_PIN_NR					= 2
.equ TAKT_PIN						= PIND
.equ TAKT_DDR						= DDRD
.equ TAKT_PORT						= PORTD
; EINGANG RDS-DATA								
.equ DATA_PIN_NR					= 4
.equ DATA_PIN						= PIND
.equ DATA_DDR						= DDRD
.equ DATA_PORT						= PORTD
; EINGANG FREQUENZZHLER						
.equ FREQU_PIN_NR					= 3
.equ FREQU_PIN						= PIND
.equ FREQU_DDR						= DDRD
.equ FREQU_PORT						= PORTD
; EINGANG TASTE-1								
.equ TASTE1_PIN_NR					= 0
.equ TASTE1_PIN						= PINB
.equ TASTE1_DDR						= DDRB
.equ TASTE1_PORT					= PORTB
; EINGANG TASTE-2								
.equ TASTE2_PIN_NR					= 1
.equ TASTE2_PIN						= PINB
.equ TASTE2_DDR						= DDRB
.equ TASTE2_PORT					= PORTB
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; BEEP											
.equ BEEP_PIN_NR					= 0
.equ BEEP_DDR						= DDRD
.equ BEEP_PORT						= PORTD
; RELAIS										
.equ RELAIS_PIN_NR					= 2
.equ RELAIS_DDR						= DDRC
.equ RELAIS_PORT					= PORTC
; LCD (DATA)									
.equ LCD_DATA0_DDR					= DDRB
.equ LCD_DATA1_DDR					= DDRB
.equ LCD_DATA2_DDR					= DDRB
.equ LCD_DATA3_DDR					= DDRB
.equ LCD_DATA0_PORT					= PORTB
.equ LCD_DATA1_PORT					= PORTB
.equ LCD_DATA2_PORT					= PORTB
.equ LCD_DATA3_PORT					= PORTB
.equ LCD_DATA0						= 2
.equ LCD_DATA1						= 3
.equ LCD_DATA2						= 4
.equ LCD_DATA3						= 5
; LCD (RS)										
.equ LCD_RS_PORT					= PORTC
.equ LCD_RS_DDR						= DDRC
.equ LCD_RS							= 0
; LCD (E)										
.equ LCD_EN_PORT					= PORTC
.equ LCD_EN_DDR						= DDRC
.equ LCD_EN							= 1
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN						=SRAM_START+0		; 0x0060 START Adresse 							

.equ adr_ERROR_CODE					=SRAM_START+1		; ERROR CODE vom ersten auftretenden Fehler		
.equ adr_MENUE						=SRAM_START+2		; Menuedarstellung								
.equ adr_TASTE						=SRAM_START+3		; Taste / Tastatur								

.equ adr_BEEP_OFF					=SRAM_START+4
.equ adr_LED_OFF					=SRAM_START+5
.equ adr_RELAIS_OFF					=SRAM_START+6

.equ adr_FREQUENZA_0				=SRAM_START+10		; FREQUENZ (LSB)								
.equ adr_FREQUENZA_1				=SRAM_START+11		; FREQUENZ (MSB)								

.equ adr_FREQUENZB_ZAEHLER			=SRAM_START+12		; FREQUENZ-Hifszhler-B							
.equ adr_FREQUENZB_0				=SRAM_START+13		; FREQUENZ (LSB)								
.equ adr_FREQUENZB_1				=SRAM_START+14		; FREQUENZ 										
.equ adr_FREQUENZB_2				=SRAM_START+15		; FREQUENZ (MSB)								

.equ adr_FREQUENZC_ZAEHLER			=SRAM_START+16		; FREQUENZ-Hifszhler-C							
.equ adr_FREQUENZC_0				=SRAM_START+17		; FREQUENZ (LSB)								
.equ adr_FREQUENZC_1				=SRAM_START+18		; FREQUENZ 										
.equ adr_FREQUENZC_2				=SRAM_START+19		; FREQUENZ (MSB)								

.equ adr_RDS_ZAEHLER_ANZ_GRUPPEN_L	=SRAM_START+20		; STATISTIK										
.equ adr_RDS_ZAEHLER_ANZ_GRUPPEN_H	=SRAM_START+21
.equ adr_RDS_ZAEHLER_ANZ_GRUPPEN_ERROR_L=SRAM_START+22	; STATISTIK										
.equ adr_RDS_ZAEHLER_ANZ_GRUPPEN_ERROR_H=SRAM_START+23

.equ adr_RDS_ZAEHLER_AF				=SRAM_START+30 		; ZAEHLER fr AF Darstellung				
.equ adr_RDS_ZAEHLER_USART			=SRAM_START+31		; USART (DATENSTROM)
.equ adr_RDS_ZAEHLER_BYTES			=SRAM_START+32		; Hilfszhler		
.equ adr_RDS_ZAEHLER_GRUPPENTYP		=SRAM_START+33		; Hilfszhler		
.equ adr_RDS_ZAEHLER_BUFFER_WRITE	=SRAM_START+34		; Hilfszhler		
.equ adr_RDS_ZAEHLER_BUFFER_READ	=SRAM_START+35		; Hilfszhler		

.equ adr_RDS_DATA0					=SRAM_START+40 		; LSB (Rohdaten)
.equ adr_RDS_DATA1					=SRAM_START+41
.equ adr_RDS_DATA2					=SRAM_START+42
.equ adr_RDS_DATA3					=SRAM_START+43		; MSB (Rohdaten)

.equ adr_RDS_GRUPPE_AH_ROH			=SRAM_START+50		; ROHDATEN
.equ adr_RDS_GRUPPE_AL_ROH			=SRAM_START+51
.equ adr_RDS_GRUPPE_BH_ROH			=SRAM_START+52
.equ adr_RDS_GRUPPE_BL_ROH			=SRAM_START+53
.equ adr_RDS_GRUPPE_CH_ROH			=SRAM_START+54
.equ adr_RDS_GRUPPE_CL_ROH			=SRAM_START+55
.equ adr_RDS_GRUPPE_DH_ROH			=SRAM_START+56
.equ adr_RDS_GRUPPE_DL_ROH			=SRAM_START+57

.equ adr_RDS_AH						=SRAM_START+60 		; GRUPPE (DISPLAY)	
.equ adr_RDS_AL						=SRAM_START+61
.equ adr_RDS_BH						=SRAM_START+62
.equ adr_RDS_BL						=SRAM_START+63
.equ adr_RDS_CH						=SRAM_START+64
.equ adr_RDS_CL						=SRAM_START+65
.equ adr_RDS_DH						=SRAM_START+66
.equ adr_RDS_DL						=SRAM_START+67

.equ adr_RDS_AH_OLD					=SRAM_START+68 		; Gruppe(OLD)		
.equ adr_RDS_AL_OLD					=SRAM_START+69

.equ adr_RDS_PI_L					=SRAM_START+80	; PI										
.equ adr_RDS_PI_H					=SRAM_START+81 	; PI										
.equ adr_RDS_GT						=SRAM_START+82 	; Gruppentyp								
.equ adr_RDS_PTY					=SRAM_START+83 	; PTY										
.equ adr_RDS_TP						=SRAM_START+84 	; Traffic Programm 		(Verkehsfunk)		
.equ adr_RDS_TA						=SRAM_START+85 	; Traffic Announcement 	(Verkehrsdurchsage)	
.equ adr_RDS_MS						=SRAM_START+86 	; Musik / Sprache							
.equ adr_RDS_ZEIT_HH				=SRAM_START+87 	; RDS-ZEIT									
.equ adr_RDS_ZEIT_MM				=SRAM_START+88 	; RDS-ZEIT									
.equ adr_RDS_ZEIT_OFFSET			=SRAM_START+89 	; RDS-ZEIT (Offset)							


.equ adr_RDS_BEREICH_SENDERNAME8	=SRAM_START+100	;   8 Bytes fr Sendername					
.equ adr_RDS_BEREICH_GRUPPENNUMMERN32=SRAM_START+110;  32 Bytes	fr empfangene Gruppennummern	
.equ adr_RDS_BEREICH_RADIOTEXT128	=SRAM_START+180	; 128 Bytes	fr Radiotext					
.equ adr_RDS_BEREICH_AF128			=SRAM_START+310	; 128 Bytes fr Alternativfrequenzen		
.equ adr_RDS_DISPLAY_BUFFER256		=SRAM_START+440	; 256 BYTES fr PUFFER (DISPLAY)			

.equ adr_SRAM_CHECK					=SRAM_START+960	; SRAM CHECK muss immer "S" sein !			

; REGISTER										
.def FREQA0		= R0		; Frequenz-A Hilfsszhler	
.def FREQA1		= R1

.def FREQB0		= R2		; Frequenz-B Hilfsszhler	
.def FREQB1		= R3
.def FREQB2		= R4

.def FREQC0		= R5		; Frequenz-C Hilfsszhler	
.def FREQC1		= R6
.def FREQC2		= R7

.def SEKUNDE	= R8

.def NULL 		= R14
.def EINS 		= R15

.def temp 		= R16
.def temp1 		= R17
.def temp2 		= R18
.def temp3 		= R19
.def temp4 		= R20
.def temp5 		= R21
.def temp6 		= R22
.def temp7 		= R23
.def temp8 		= R24
.def temp9 		= R25





.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0				

rjmp RESET      		; Reset Handler                           				
rjmp EXT_INT0   		; IRQ0 Handler                      					
rjmp EXT_INT1   		; IRQ1 Handler                      					
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       						
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Unkorrekten Interrupt Aufruf (nur GRN blinkt)	
INTERRUPT_ERROR:
	CLI											; Interrupts sperren !				
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
	rcall wait_100ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus  
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus  
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM lschen										
	rcall SRAM_CLEAR
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; SRAM				
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; FREQUENZ_ZAEHLER	
	ldi temp,2
	STS(adr_FREQUENZB_ZAEHLER),temp
	STS(adr_FREQUENZC_ZAEHLER),temp
	; REGISTER			
	clr FREQA0
	clr FREQA1
	clr FREQB0
	clr FREQB1
	clr FREQB2
	clr FREQC0
	clr FREQC1
	clr FREQC2
; PORT B+C+D auf EINGANG							
	out DDRB,  NULL
	out DDRC,  NULL
	out DDRD,  NULL
	out PORTB, NULL
	out PORTC, NULL
	out PORTD, NULL
; PORT LED											
	sbi (LED_GRUEN_DDR),(LED_GRUEN_PIN_NR)		; auf AUSGANG
	sbi (LED_GELB_DDR) ,(LED_GELB_PIN_NR)		; auf AUSGANG
	sbi (LED_ROT_DDR)  ,(LED_ROT_PIN_NR)		; auf AUSGANG
; LEDs an											
	cbi (LED_GRUEN_PORT),(LED_GRUEN_PIN_NR)		; GRN an	
	cbi (LED_GELB_PORT) ,(LED_GELB_PIN_NR)		; GELB an	
	cbi (LED_ROT_PORT)  ,(LED_ROT_PIN_NR)		; ROT an	
; BEEP												
	sbi (BEEP_DDR) ,(BEEP_PIN_NR)				; AUSGANG	
	sbi (BEEP_PORT),(BEEP_PIN_NR)				; aus		
; RELAIS											
	sbi (RELAIS_DDR) ,(RELAIS_PIN_NR)			; AUSGANG	
	sbi (RELAIS_PORT),(RELAIS_PIN_NR)			; aus		
; EINGNGE											
	cbi (TAKT_DDR)  ,(TAKT_PIN_NR)		; RDS-TAKT			
	cbi (DATA_DDR)  ,(DATA_PIN_NR)		; RDS-DATA			
	cbi (TASTE1_DDR),(TASTE1_PIN_NR)	; TASTE				
	cbi (TASTE2_DDR),(TASTE2_PIN_NR)	; TASTE				
	cbi (FREQU_DDR) ,(FREQU_PIN_NR)		; FREQUENZZHLER	
; PULL-UPs ein										
	sbi (TAKT_PORT)  ,(TAKT_PIN_NR)		; RDS-TAKT			
	sbi (DATA_PORT)  ,(DATA_PIN_NR)		; RDS-DATA			
	sbi (TASTE1_PORT),(TASTE1_PIN_NR)	; TASTE				
	sbi (TASTE2_PORT),(TASTE2_PIN_NR)	; TASTE				
	sbi (FREQU_PORT) ,(FREQU_PIN_NR)	; FREQUENZZHLER	
; WDR_INITIALISIERUNG								
	rcall WDR_INITIALISIERUNG
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; LED-TEST											
	rcall LED_TEST
; EXTERNER_INTERUPT_INITIALISIEREN					
	rcall EXTERNER_INTERUPT_INITIALISIEREN
; EXTERNER_INTERRUPT_AKTIVIEREN						
	rcall EXTERNER_INTERRUPT_AKTIVIEREN						
; TIMER1_INITIALISIERUNG							
	rcall TIMER1_INITIALISIERUNG
; TIMER_AKTIVIEREN									
	rcall TIMER_AKTIVIEREN
; LCD-INITIALISIERUNG								
	rcall LCD_INITIALISIERUNG
; LCD-TEST											
	rcall ANZEIGE_TEST
	rcall wait_100ms
; LCD-ANZEIGE_BEGRUESSUNG							
	rcall ANZEIGE_BEGRUESSUNG_4_ZEILEN
; 	PROGRAMM_CHECK									
	rcall PROGRAMM_CHECK
; 	RDS												
	rcall RDS_CLEAR
	rcall wait_100ms
; Interrupts freigeben								
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR										; Watch-Dog-RESET	
	rcall RDS_BUFFER_READ
	rcall PROGRAMM_CHECK
	rcall wait_100ms
	rcall wait_100ms
	rcall wait_100ms
	rcall TASTEN_KLICK
	rcall TASTEN_RESET
	rcall VERKEHRSDURCHSAGE
	rcall MENUE
	rcall ANZEIGE_ERROR
	STS(adr_TASTE),NULL
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	; TASTE laden			
	LDS temp,(adr_TASTE)
MENUE_w:
	; TASTE PLUS gedrckt ?	
	cpi temp,(TASTE_MENUE_PLUS)
	breq MENUE_PLUS
	; TASTE MINUS gedrckt ?
	cpi temp,(TASTE_MENUE_MINUS)
	breq MENUE_MINUS
	rjmp MENUE_NO_TASTE
MENUE_PLUS:
	; MENUE +1			
	LDS temp,(adr_MENUE)
	inc temp
	STS (adr_MENUE),temp
	rcall LCD_CLEAR 
	rjmp MENUE_NO_TASTE
MENUE_MINUS:
	; MENUE -1			
	LDS temp,(adr_MENUE)
	; berlauf behandeln
	tst temp
	breq MENUE_NO_TASTE
	; sperren			
	cpi temp,10
	brsh MENUE_NO_TASTE
	dec temp
	STS (adr_MENUE),temp
	rcall LCD_CLEAR 
MENUE_NO_TASTE:
;-------------------------------------------------------------------------------
MENUE_RUN:
	; Z initialisieren	
	LDS temp,(adr_MENUE)
	ldi ZL,LOW (MENUE_SPRUNGMARKE)
	ldi ZH,HIGH(MENUE_SPRUNGMARKE)
	add ZL,temp 
	adc ZH,NULL
	; SPRUNG nach Z		
	ijmp
MENUE_SPRUNGMARKE:
	rjmp ANZEIGE_HAUPTMENUE
	rjmp ANZEIGE_RADIOTEXT_SEITE_A
	rjmp ANZEIGE_RADIOTEXT_SEITE_B
	rjmp ANZEIGE_PI
	rjmp ANZEIGE_PTY
	rjmp ANZEIGE_GESENDETE_GRUPPENTYPEN
	rjmp ANZEIGE_LISTE_AF_SEITE1
	rjmp ANZEIGE_LISTE_AF_SEITE2
	rjmp ANZEIGE_LISTE_AF_SEITE3
	rjmp ANZEIGE_STATISTIK
	rjmp ANZEIGE_FREQUENZ
	rjmp ANZEIGE_EDIT_BEEP
	rjmp ANZEIGE_EDIT_LED
	rjmp ANZEIGE_EDIT_RELAIS
	rjmp ANZEIGE_BEGRUESSUNG_4_ZEILEN
	; berlauf
	STS(adr_MENUE),NULL
	rjmp MENUE_RUN
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "RDSOLCD_TIMER.asm"			; TIMER							
.include "RDSOLCD_INTERRUPT.asm"		; ext.INTERRUPTS				
.include "RDSOLCD_RDS_ROHDATEN.asm"		; RDS-Rohdaten					
.include "RDSOLCD_RDS.asm"				; RDS							
.include "RDSOLCD_LCD.asm"				; LCD allgemein					
.include "RDSOLCD_LCD_ini.asm"			; LCD  Initialisierung			
.include "RDSOLCD_LCD_KURZ.asm"			; LCD kurz						
.include "RDSOLCD_EEPROM.asm"			; EEPROM						
.include "RDSOLCD_SONSTIGES.asm"		; sonstiges						
.include "RDSOLCD_WAIT_16MHZ.asm"		; 16 MHz						
; ##############################################################################
; ##############################################################################
; ##############################################################################
TEXT_BEGRUESSUNG_1:
.db "RDS-DECODER",0
TEXT_BEGRUESSUNG_2:
.db "OLCD-TWI-USART",0
TEXT_BEGRUESSUNG_3:
.db "ATmega8 / 16MHz",0
TEXT_BEGRUESSUNG_4:
.db "30.06.2014 ",0

TEXT_PILOTFREQUENZ:
.db "Pilotfrequenz",0

TEXT_PTY_00: 
.db "kein PTY",0
TEXT_PTY_01: 
.db "Nachrichten",0 
TEXT_PTY_02: 
.db "Aktuelles",0 
TEXT_PTY_03: 
.db "Information",0 
TEXT_PTY_04: 
.db "Sport",0 
TEXT_PTY_05: 
.db "Bildung",0 
TEXT_PTY_06: 
.db "Hrspiel",0 
TEXT_PTY_07: 
.db "Kultur",0 
TEXT_PTY_08: 
.db "Wissenschaft",0 
TEXT_PTY_09: 
.db "Unterhaltung (Wort)",0 
TEXT_PTY_10: 
.db "Popmusik",0
TEXT_PTY_11: 
.db "Rockmusik",0 
TEXT_PTY_12: 
.db "Unterhaltungsmusik",0 
TEXT_PTY_13: 
.db "Leichte Klassik",0 
TEXT_PTY_14: 
.db "Ernste Klassik",0 
TEXT_PTY_15: 
.db "Andere Musik",0 
TEXT_PTY_16: 
.db "Wetter",0
TEXT_PTY_17: 
.db "Finanzen",0
TEXT_PTY_18: 
.db "Kinderprogramm",0
TEXT_PTY_19: 
.db "Gesellschaftliches",0
TEXT_PTY_20: 
.db "Religion",0
TEXT_PTY_21: 
.db "Telefonieren",0
TEXT_PTY_22: 
.db "Reisen",0
TEXT_PTY_23: 
.db "Freizeit",0
TEXT_PTY_24: 
.db "Jazzmusik",0
TEXT_PTY_25: 
.db "Countrymusik",0
TEXT_PTY_26: 
.db "Nationale Musik",0
TEXT_PTY_27: 
.db "Oldies",0
TEXT_PTY_28: 
.db "Volksmusik",0
TEXT_PTY_29: 
.db "Dokumentationen",0
TEXT_PTY_30: 
.db "Testalarm",0
TEXT_PTY_31: 
.db "Alarm",0


; Erste Ziffer = Land					
TEXT_PI_ZIFFER1_0: 
.db "0",0
TEXT_PI_ZIFFER1_1: 
.db "1",0
TEXT_PI_ZIFFER1_2: 
.db "2",0
TEXT_PI_ZIFFER1_3: 
.db "3",0
TEXT_PI_ZIFFER1_4: 
.db "4",0
TEXT_PI_ZIFFER1_5: 
.db "5",0
TEXT_PI_ZIFFER1_6: 
.db "6",0
TEXT_PI_ZIFFER1_7: 
.db "7",0
TEXT_PI_ZIFFER1_8: 
.db "8",0
TEXT_PI_ZIFFER1_9: 
.db "9",0
TEXT_PI_ZIFFER1_A: 
.db "A",0
TEXT_PI_ZIFFER1_B: 
.db "B",0
TEXT_PI_ZIFFER1_C: 
.db "C",0
TEXT_PI_ZIFFER1_D: 
.db "DEUTSCHLAND",0
TEXT_PI_ZIFFER1_E: 
.db "D",0
TEXT_PI_ZIFFER1_F: 
.db "F",0
; Zweite Ziffer = Gre des Sendebereichs
TEXT_PI_ZIFFER2_0: 
.db "lokal",0
TEXT_PI_ZIFFER2_1: 
.db "intern",0
TEXT_PI_ZIFFER2_2: 
.db "natio",0
TEXT_PI_ZIFFER2_3: 
.db "ueber",0
TEXT_PI_ZIFFER2_4: 
.db "reg",0
TEXT_PI_ZIFFER2_5: 
.db "reg",0
TEXT_PI_ZIFFER2_6: 
.db "reg",0
TEXT_PI_ZIFFER2_7: 
.db "reg",0
TEXT_PI_ZIFFER2_8: 
.db "reg",0
TEXT_PI_ZIFFER2_9: 
.db "reg",0
TEXT_PI_ZIFFER2_A: 
.db "reg",0
TEXT_PI_ZIFFER2_B: 
.db "reg",0
TEXT_PI_ZIFFER2_C: 
.db "reg",0
TEXT_PI_ZIFFER2_D: 
.db "reg",0
TEXT_PI_ZIFFER2_E: 
.db "reg",0
TEXT_PI_ZIFFER2_F: 
.db "reg",0
; Dritte Ziffer = Bundesland od. Zhler
TEXT_PI_ZIFFER3_0: 
.db "Baden-Wrttemberg",0
TEXT_PI_ZIFFER3_1: 
.db "Bayern",0
TEXT_PI_ZIFFER3_2: 
.db "Berlin",0
TEXT_PI_ZIFFER3_3: 
.db "Brandenburg",0
TEXT_PI_ZIFFER3_4: 
.db "Bremen",0 
TEXT_PI_ZIFFER3_5: 
.db "Hamburg",0
TEXT_PI_ZIFFER3_6: 
.db "Hessen",0
TEXT_PI_ZIFFER3_7: 
.db "Mecklenburg-Vorpommern",0
TEXT_PI_ZIFFER3_8: 
.db "Niedersachsen",0
TEXT_PI_ZIFFER3_9: 
.db "Nordrhein-Westfalen",0
TEXT_PI_ZIFFER3_A: 
.db "Rheinland-Pfalz",0
TEXT_PI_ZIFFER3_B: 
.db "Saarland",0
TEXT_PI_ZIFFER3_C: 
.db "Sachsen privat",0
TEXT_PI_ZIFFER3_D: 
.db "Sachsen-Anhalt",0
TEXT_PI_ZIFFER3_E: 
.db "Schleswig-Holstein",0
TEXT_PI_ZIFFER3_F: 
.db "Thringen",0

; Vierte Ziffer = Identifikation Sender od. Zhler
TEXT_PI_ZIFFER4_0: 
.db "oeffentl",0
TEXT_PI_ZIFFER4_1: 
.db "oeffentl",0
TEXT_PI_ZIFFER4_2: 
.db "oeffentl",0
TEXT_PI_ZIFFER4_3: 
.db "oeffentl",0
TEXT_PI_ZIFFER4_4: 
.db "oeffentl",0
TEXT_PI_ZIFFER4_5: 
.db "oeffentl",0
TEXT_PI_ZIFFER4_6: 
.db "oeffentl",0
TEXT_PI_ZIFFER4_7: 
.db "oeffentl",0
TEXT_PI_ZIFFER4_8: 
.db "privat",0
TEXT_PI_ZIFFER4_9: 
.db "privat",0
TEXT_PI_ZIFFER4_A: 
.db "privat",0
TEXT_PI_ZIFFER4_B: 
.db "privat",0
TEXT_PI_ZIFFER4_C: 
.db "privat",0
TEXT_PI_ZIFFER4_D: 
.db "privat",0
TEXT_PI_ZIFFER4_E: 
.db "privat",0
TEXT_PI_ZIFFER4_F: 
.db "privat",0
